var split = require('browser-split')
var ClassList = require('class-list')
var w = typeof window === 'undefined' ? require('html-element') : window
var document = w.document
var Text = w.Text
module.exports = function () {
    var args = [].slice.call(arguments), e = null
    function item(l) {
        var r
        function parseClass(string) {
            var m = split(string, /([\.#]?[^\s#.]+)/)
            if (/^\.|#/.test(m[1]))
                e = document.createElement('div')
            forEach(m, function (v) {
                var s = v.substring(1, v.length)
                if (!v) return
                if (!e) {
                    e = document.createElement(v)
                    e.events = {};
                }
                else if (v[0] === '.')
                    ClassList(e).add(s)
                else if (v[0] === '#')
                    e.setAttribute('id', s)
            })
        }
        if ('string' === typeof l) {
            if (!e)
                parseClass(l)
            else
                e.appendChild(r = document.createTextNode(l))
        }
        else if ('number' === typeof l
            || 'boolean' === typeof l
            || l instanceof Date
            || l instanceof RegExp) {
            e.appendChild(r = document.createTextNode(l.toString()))
        }
        //there might be a better way to handle this...
        else if (isArray(l))
            forEach(l, item)
        else if (isNode(l))
            e.appendChild(r = l)
        else if (l instanceof Text)
            e.appendChild(r = l)
        else if ('object' === typeof l) {
            for (var k in l) {
                if ('function' === typeof l[k]) {
                    if (/^on\w+/.test(k)) {
                        e.events[k.substring(2)] = l[k];
                    } else {
                        e[k] = l[k]()
                    }
                }
                else if (k === 'style') {
                    if ('string' === typeof l[k]) {
                        e.style.cssText = l[k]
                    } else {
                        for (var s in l[k]) (function (s, v) {
                            if ('function' === typeof v) {
                                // observable
                                e.style.setProperty(s, v())
                            } else
                                var match = l[k][s].match(/(.*)\W+!important\W*$/);
                            if (match) {
                                e.style.setProperty(s, match[1], 'important')
                            } else {
                                e.style.setProperty(s, l[k][s])
                            }
                        })(s, l[k][s])
                    }
                } else if (k === 'attrs') {
                    for (var v in l[k]) {
                        e.setAttribute(v, l[k][v])
                    }
                }
                else if (k.substr(0, 5) === "data-") {
                    e.setAttribute(k, l[k])
                } else {
                    e[k] = l[k]
                }
            }
        } else if ('function' === typeof l) {
            e.appendChild(r = isNode(v) ? v : document.createTextNode(v))
        }
        return r
    }
    while (args.length)
        item(args.shift())
    return e
}
function isNode(el) {
    return el && el.nodeName && el.nodeType
}
function forEach(arr, fn) {
    if (arr.forEach) return arr.forEach(fn)
    for (var i = 0; i < arr.length; i++) fn(arr[i], i)
}
function isArray(arr) {
    return Object.prototype.toString.call(arr) == '[object Array]'
}